Index: external/fastjet/contribs/RecursiveTools/README
===================================================================
--- external/fastjet/contribs/RecursiveTools/README	(revision 1f1f858be3b07de5df7883fba72ff0a8ab002b56)
+++ external/fastjet/contribs/RecursiveTools/README	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -17,8 +17,19 @@
   Marzani, Gregory Soyez, Jesse Thaler
 
+- RecursiveSoftDrop
+- BottomUpSoftDrop
+  This corresponds to arXiv:1804.03657 by Frederic Dreyer, Lina
+  Necib, Gregory Soyez and Jesse Thaler
+
+- IteratedSoftDrop
+  This corresponds to arXiv:1704.06266 by Christopher Frye, Andrew J.
+  Larkoski, Jesse Thaler, Kevin Zhou
+
 - Recluster
   A generic tool to recluster a given jet into subjets
-  Note: this is largely based on the Filter code in FastJet v3.0 and
-  ultimately, this tool will probably be moved into FastJet
+  Note: a Recluster class is available natively in FastJet since v3.1.
+        Users are therefore encouraged to use the FastJet version
+        rather than this one which is mostly provided for
+        compatibility of this contrib with older versions of FastJet.
 
 The interface for these tools is described in more detail below, with
@@ -74,5 +85,5 @@
 
 The SoftDrop procedure is very similar to mMDT, albeit with a 
-generalized symmetry condition:
+generalised symmetry condition:
  
    z > z_cut * (R / R0)^beta
@@ -108,11 +119,116 @@
 
 ------------------------------------------------------------------------
+RecursiveSoftDrop
+------------------------------------------------------------------------
+
+The RecursiveSoftDrop procedure applies the Soft Drop procedure N times 
+in a jet in order to find up to N+1 prongs.  N=0 makes no modification
+to the jet, and N=1 is equivalent to the original SoftDrop.
+
+Once one has more than one prong, one has to decide which will be
+declustered next.  At each step of the declustering procedure, one
+undoes the clustering which has the largest declustering angle
+(amongst all the branches that are searched for substructure). [see
+"set_fixed_depth" below for an alternative]
+
+Compared to SoftDrop, RecursiveSoftDrop takes an extra argument N
+specifying the number of times the SoftDrop procedure is recursively
+applied. Negative N means that the procedure is applied until no
+further substructure is found (i.e. corresponds to taking N=infinity).
+
+   double z_cut = 0.10;
+   double beta  = 2.0;
+   double R0    = 1.0; // this is the default value
+   int N        = -1;  
+   RecursiveSoftDrop rsd(z_cut, beta, N, R0);
+
+One then acts on a jet as
+
+   PseudoJet groomed_jet = rsd(jet)
+
+and get additional information via
+
+   groomed_jet.structure_of<RecursiveSoftDrop>()
+
+------------------------------------------------------------------------
+IteratedSoftDrop
+------------------------------------------------------------------------
+
+Iterated Soft Drop (ISD) is a repeated variant of SoftDrop.  After
+performing the Soft Drop procedure once, it logs the groomed symmetry
+factor, then recursively performs Soft Drop again on the harder
+branch.  This procedure is repeated down to an (optional) angular cut
+theta_cut, yielding a set of symmetry factors from which observables
+can be built.
+
+An IteratedSoftDrop tool can be created as follows:
+
+  double beta = -1.0;
+  double z_cut = 0.005;
+  double theta_cut = 0.0;
+  double R0 = 0.5;        // characteristic radius of jet algorithm
+  IteratedSoftDrop isd(beta, z_cut, double theta_cut, R0);
+
+By default, ISD applied on a jet gives a result of type
+IteratedSoftDropInfo that can then be probed to obtain physical
+observables
+
+  IteratedSoftDropInfo isd_info = isd(jet);
+
+  unsigned int multiplicity = isd_info.multiplicity();
+  double kappa = 1.0;     // changes angular scale of ISD angularity
+  double isd_width = isd_info.angularity(kappa);
+  vector<pair<double,double> > zg_thetags = isd_info.all_zg_thetag();
+  vector<pair<double,double> > zg_thetags = isd_info();
+  for (unsigned int i=0; i< isd_info.size(); ++i){
+    cout << "(zg, theta_g)_" << i << " = "
+         << isd_info[i].first << " " <<  isd_info[i].second << endl;
+  }
+
+Alternatively, one can directly get the multiplicity, angularity, and
+(zg,thetag) pairs from the IteratedSoftDrop class, at the expense of
+re-running the declustering procedure:
+
+  unsigned int multiplicity = isd.multiplicity(jet);
+  double isd_width = isd.angularity(jet, 1.0);
+  vector<pair<double,double> > zg_thetags = isd.all_zg_thetag(jet);
+
+
+Note: the iterative declustering procedure is the same as what one
+  would obtain with RecursiveSoftDrop with an (optional) angular cut
+  and recursing only in the hardest branch [see the "Changing
+  behaviour" section below for details], except that it returns some
+  information about the jet instead of a modified jet as RSD does.
+
+
+------------------------------------------------------------------------
+BottomUpSoftDrop
+------------------------------------------------------------------------
+
+This is a bottom-up version of the RecursiveSoftDrop procedure, in a
+similar way as Pruning can be seen as a bottom-up version of Trimming.
+
+In practice, the jet is reclustered and at each step of the clustering
+one checks the SoftDrop condition
+
+   z > z_cut * (R / R0)^beta
+
+If the condition is met, the pair is recombined. If the condition is
+not met, only the hardest of the two objects is kept for further
+clustering and the softest is rejected.
+
+------------------------------------------------------------------------
 Recluster
 ------------------------------------------------------------------------
+
+  *** NOTE: this is provided only for backwards compatibility ***
+  *** with FastJet <3.1. For FastJet >=3.1, the native        ***
+  *** fastjet::Recluster is used instead                      ***
 
 The Recluster class allows the constituents of a jet to be reclustered
 with a different recursive clustering algorithm.  This is used
-internally in the mMDT/SoftDrop code in order to recluster the jet using
-the CA algorithm.  This is achieved via
+internally in the mMDT/SoftDrop/RecursiveSoftDrop/IteratedSoftDrop
+code in order to recluster the jet using the CA algorithm.  This is
+achieved via
 
   Recluster ca_reclusterer(cambridge_algorithm,
@@ -123,24 +239,37 @@
 delete_self_when_unused.
 
-
 ------------------------------------------------------------------------
 Changing behaviour
 ------------------------------------------------------------------------
 
-The behaviour of the ModifiedMassDropTagger and SoftDrop classes can
-be tweaked using the following options:
-
-SymmetryMeasure = {scalar_z,vector_z,y}  [constructor argument]
+The behaviour of the all the tools provided here
+(ModifiedMassDropTagger, SoftDrop, RecursiveSoftDrop and
+IteratedSoftDrop) can be tweaked using the following options:
+
+SymmetryMeasure = {scalar_z, vector_z, y, theta_E, cos_theta_E}
+  [constructor argument]
   : The definition of the energy sharing between subjets, with 0
-    corresponding to the most asymmetric
-
-RecursionChoice = {larger_pt,larger_mt,larger_m}  [constructor argument]
+    corresponding to the most asymmetric.
+    . scalar_z = min(pt1,pt2)/(pt1+pt2)   [default]
+    . vector_z = min(pt1,pt2)/pt_{1+2}
+    . y = min(pt1^2,pt2^2)/m_{12}^2  (original y from MDT)
+    . theta_E     = min(E1,E2)/(E1+E2),
+           with angular measure theta_{12}^2
+    . cos_theta_E = min(E1,E2)/(E1+E2),
+           with angular measure 2[1-cos(theta_{12})]
+    The last two variants are meant for use in e+e- collisions,
+    together with the "larger_E" recursion choice (see below)
+
+RecursionChoice = {larger_pt, larger_mt, larger_m, larger_E}
+  [constructor argument]
   : The path to recurse through the tree after the symmetry condition
-    fails
+    fails. Options refer to transverse momentum (pt), transverse mass
+    (mt=sqrt(pt^2+m^2), mass (m) or energy (E). the latter is meant
+    for use in e+e- collisions
 
 mu_cut   [constructor argument]
   : An optional mass drop condition
 
-set_subtractor(subtractor*) [or subtracter as a constructor argument]
+set_subtractor(subtractor*) [or subtractor as a constructor argument]
   : provide a subtractor. When a subtractor is supplied, the
     kinematic constraints are applied on subtracted 4-vectors. In
@@ -165,4 +294,35 @@
     and SoftDrop defaults to grooming mode.
 
+set_verbose_structure(bool)
+  : when set to true, additional information will be stored in the jet
+    structure. This includes in particular values of symmetry,
+    delta_R, and mu of dropped branches
+
+For the specific case of RecursiveSoftDrop, additional tweaking is
+possible via the following methods
+
+set_fixed_depth_mode(bool)
+  : when this is true, RSD will recurse (N times) into all the
+    branches found during the previous iteration [instead of recursing
+    through the largest declustering angle until N prongs have been
+    found]. This yields at most 2^N prong. For infinite N, the two
+    options are equivalent.
+
+set_dynamical_R0(bool)
+  : By default the angles in the SD condition are normalised to the
+    parameter R0. With "dynamical R0", RSD will dynamically adjust R0
+    to be the angle between the two prongs found during the previous
+    iteration.
+
+set_hardest_branch_only(bool)
+  : When substructure is found, only recurse into the hardest of the
+    two branches for further substructure search. This uses the class
+    RecursionChoice.
+
+set_min_deltaR_squared(double):
+  : set a minimal angle (squared) at which we stop the declustering
+    procedure.  This cut is ineffective for negative values of the
+    argument.
+
 ------------------------------------------------------------------------
 Technical Details
Index: external/fastjet/contribs/RecursiveTools/Recluster.hh
===================================================================
--- external/fastjet/contribs/RecursiveTools/Recluster.hh	(revision 1f1f858be3b07de5df7883fba72ff0a8ab002b56)
+++ external/fastjet/contribs/RecursiveTools/Recluster.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
-#ifndef __FASTJET_TOOLS_RECLUSTER_HH__
-#define __FASTJET_TOOLS_RECLUSTER_HH__
+#ifndef __FASTJET_CONTRIB_TOOLS_RECLUSTER_HH__
+#define __FASTJET_CONTRIB_TOOLS_RECLUSTER_HH__
 
-// $Id: Recluster.hh 700 2014-07-07 12:50:05Z gsoyez $
+// $Id: Recluster.hh 723 2014-07-30 09:11:01Z gsoyez $
 //
 // Copyright (c) 2014-, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -181,3 +181,3 @@
 FASTJET_END_NAMESPACE      // defined in fastjet/internal/base.hh
 
-#endif   // __FASTJET_TOOLS_RECLUSTER_HH__
+#endif   // __FASTJET_CONTRIB_TOOLS_RECLUSTER_HH__
Index: external/fastjet/contribs/RecursiveTools/RecursiveSoftDrop.cc
===================================================================
--- external/fastjet/contribs/RecursiveTools/RecursiveSoftDrop.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
+++ external/fastjet/contribs/RecursiveTools/RecursiveSoftDrop.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -0,0 +1,482 @@
+// $Id: RecursiveSoftDrop.cc 1111 2018-04-04 10:06:11Z gsoyez $
+//
+// Copyright (c) 2017-, Gavin P. Salam, Gregory Soyez, Jesse Thaler,
+// Kevin Zhou, Frederic Dreyer
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#include "RecursiveSoftDrop.hh"
+#include "fastjet/ClusterSequence.hh"
+
+using namespace std;
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib{
+
+namespace internal_recursive_softdrop{
+  
+//========================================================================
+/// \class RSDHistoryElement
+/// a helper class to help keeping track od the RSD tree
+///
+/// The element is created at the top of a branch and updated each
+/// time one grooms something away.
+class RSDHistoryElement{
+public:
+  RSDHistoryElement(const PseudoJet &jet, const RecursiveSoftDrop* rsd_ptr, double R0sqr) :
+    R0_squared(R0sqr),
+    child1_in_history(-1), child2_in_history(-1), symmetry(-1.0), mu2(-1.0){
+    reset(jet, rsd_ptr);
+  }
+
+  void reset(const PseudoJet &jet, const RecursiveSoftDrop* rsd_ptr){
+    current_in_ca_tree = jet.cluster_hist_index();
+    PseudoJet piece1, piece2;
+    theta_squared = (jet.has_parents(piece1, piece2))
+      ? rsd_ptr->squared_geometric_distance(piece1,piece2) : 0.0;
+  }
+  
+  int current_in_ca_tree;  ///< (history) index of the current particle in the C/A tree 
+  double theta_squared;    ///< squared angle at which this decays
+  double R0_squared;       ///< squared angle at the top of the branch
+                           ///< (used for RSD with dynamic_R0)
+  int child1_in_history;   ///< hardest of the 2 decay products (-1 if untagged)
+  int child2_in_history;   ///< softest of the 2 decay products (-1 if untagged)
+
+  // info about what has been dropped and the local substructure
+  vector<double> dropped_delta_R;
+  vector<double> dropped_symmetry;
+  vector<double> dropped_mu;
+  double symmetry, mu2;
+};
+
+
+/// \class OrderRSDHistoryElements
+/// angular ordering of (pointers to) the history elements
+///
+/// our priority queue will use pointers to these elements that are
+/// ordered in angle (of the objects they point to)
+class OrderRSDHistoryElements{
+public:
+  bool operator()(const RSDHistoryElement *e1, const RSDHistoryElement *e2) const {
+    return e1->theta_squared < e2->theta_squared;
+  }
+};
+
+} // internal_recursive_softdrop
+  
+//========================================================================
+
+// initialise all the flags and parameters to their default value
+void RecursiveSoftDrop::set_defaults(){
+  set_fixed_depth_mode(false);
+  set_dynamical_R0(false);
+  set_hardest_branch_only(false);
+  set_min_deltaR_squared(-1.0);
+}
+
+// description of the tool
+string RecursiveSoftDrop::description() const{
+  ostringstream res;
+  res << "recursive application of ["
+      << RecursiveSymmetryCutBase::description()
+      << "]";
+  
+  if (_fixed_depth){
+    res << ", recursively applied down to a maximal depth of N=";
+    if (_n==-1) res << "infinity"; else res << _n;
+  } else {
+    res << ", applied N=";
+    if (_n==-1) res << "infinity"; else res << _n;
+    res << " times";
+  }
+  
+  if (_dynamical_R0)
+    res << ", with R0 dynamically scaled";
+  else
+    res << ", with R0 kept fixed";
+    
+  if (_hardest_branch_only)
+    res << ", following only the hardest branch";
+
+  if (_min_dR2>0)
+    res << ", with minimal angle (squared) = " << _min_dR2;
+
+  return res.str();
+}
+  
+  
+// action on a single jet with RecursiveSoftDrop.
+//
+// uses "result_fixed_tags" by default (i.e. recurse from R0 to
+// smaller angles until n SD conditions have been met), or
+// "result_fixed_depth" where each of the previous SD branches are
+// recirsed into down to a depth of n.
+PseudoJet RecursiveSoftDrop::result(const PseudoJet &jet) const{
+  return _fixed_depth ? result_fixed_depth(jet) : result_fixed_tags(jet);
+}
+
+// this routine applies the Soft Drop criterion recursively on the
+// CA tree until we find n subjets (or until it converges), and
+// adds them together into a groomed PseudoJet
+PseudoJet RecursiveSoftDrop::result_fixed_tags(const PseudoJet &jet) const {
+  // start by reclustering jet with C/A algorithm
+  PseudoJet ca_jet = _recluster_if_needed(jet);
+
+  if (! ca_jet.has_valid_cluster_sequence()){
+    throw Error("RecursiveSoftDrop can only be applied to jets associated to a (valid) cluster sequence");
+  }
+  
+  const ClusterSequence *cs = ca_jet.validated_cluster_sequence();
+  const vector<ClusterSequence::history_element> &cs_history = cs->history();
+  const vector<PseudoJet> &cs_jets = cs->jets();
+
+  // initialize counter to 1 subjet (i.e. the full ca_jet)
+  int n_tagged = 0;
+  int max_njet = ca_jet.constituents().size();
+
+  // create the list of branches
+  unsigned int max_history_size = 2*max_njet;
+  if ((_n>0) && (_n<max_njet-1)){ max_history_size = 2*(_n+1); }
+
+  // we need to pre-allocate the space for the vector so that the
+  // pointers are not invalidated
+  vector<internal_recursive_softdrop::RSDHistoryElement> history;
+  history.reserve(max_history_size);  // could be one shorter
+  history.push_back(internal_recursive_softdrop::RSDHistoryElement(ca_jet, this, _R0sqr));
+  
+  // create a priority queue containing the subjets and a comparison definition
+  // initialise to the full ca_jet
+  priority_queue<internal_recursive_softdrop::RSDHistoryElement*, vector<internal_recursive_softdrop::RSDHistoryElement*>, internal_recursive_softdrop::OrderRSDHistoryElements> active_branches;
+  active_branches.push(& (history[0]));
+
+  PseudoJet parent, piece1, piece2;
+  double sym, mu2;
+
+  // which R0 to use
+  //double R0sqr = _R0sqr;
+  
+  // loop over C/A tree until we reach the appropriate number of subjets
+  while ((continue_grooming(n_tagged)) && (active_branches.size())) {
+    // get the element corresponding to the max dR
+    // and the associated PJ
+    internal_recursive_softdrop::RSDHistoryElement * elm = active_branches.top();
+    PseudoJet parent = cs_jets[cs_history[elm->current_in_ca_tree].jetp_index];
+    
+    // do one step of SD
+    RecursionStatus status = recurse_one_step(parent, piece1, piece2, sym, mu2, &elm->R0_squared);
+
+    // check if we passed the SD condition
+    if (status==recursion_success){
+      // check for the optional angular cut
+      if ((_min_dR2 > 0) && (squared_geometric_distance(piece1,piece2) < _min_dR2))
+        break;
+
+      // both subjets are kept in the list for potential further de-clustering
+      elm->child1_in_history = history.size();
+      elm->child2_in_history = history.size()+1;
+      elm->symmetry = sym;
+      elm->mu2      = mu2;
+      active_branches.pop();
+
+      // update the history
+      double next_R0_squared = (_dynamical_R0)
+        ? piece1.squared_distance(piece2) : elm->R0_squared;
+
+      internal_recursive_softdrop::RSDHistoryElement elm1(piece1, this, next_R0_squared);
+      history.push_back(elm1);
+      active_branches.push(&(history.back()));
+      internal_recursive_softdrop::RSDHistoryElement elm2(piece2, this, next_R0_squared);
+      history.push_back(elm2);
+      if (!_hardest_branch_only){
+        active_branches.push(&(history.back()));
+      }
+      
+      ++n_tagged;
+    } else if (status==recursion_dropped){
+       // check for the optional angular cut
+      if ((_min_dR2 > 0) && (squared_geometric_distance(piece1,piece2) < _min_dR2))
+        break;
+
+      active_branches.pop();
+      // tagging failed and the softest branch should be dropped
+      // keep track of what has een groomed away
+      max_njet -= piece2.constituents().size();
+      elm->dropped_delta_R .push_back((elm->theta_squared >= 0) ? sqrt(elm->theta_squared) : -sqrt(elm->theta_squared));
+      elm->dropped_symmetry.push_back(sym);
+      elm->dropped_mu      .push_back((mu2>=0) ? sqrt(mu2) : -sqrt(mu2));
+      
+      // keep the hardest bhanch in the recursion
+      elm->reset(piece1, this);
+      active_branches.push(elm);
+    } else if (status==recursion_no_parents){
+      if (_min_dR2 > 0) break;
+      active_branches.pop();
+      // nothing specific to do: we just keep the curent jet as a "leaf"
+    } else { // recursion_issue
+      active_branches.pop();
+      // we've met an issue
+      // if the piece2 is null as well, it means we've had a critical problem.
+      // In that case, return an empty PseudoJet
+      if (piece2 == 0) return PseudoJet();
+
+      // otherwise, we should consider "piece2" as a final particle
+      // not to be recursed into
+      if (_min_dR2 > 0) break;
+      max_njet -= (piece2.constituents().size()-1);
+      break;
+    }
+    
+    // If the missing number of tags is exactly the number of objects
+    // we have left in the recursion, stop
+    if (n_tagged == max_njet) break;
+  }
+
+  // now we have a bunch of history elements that we can use to build the final jet
+  vector<PseudoJet> mapped_to_history(history.size());
+  unsigned int history_index = history.size();
+  do {
+    --history_index;
+    const internal_recursive_softdrop::RSDHistoryElement & elm = history[history_index];
+
+    // two kinds of events: either just a final leave, poteitially  with grooming
+    // or a brandhing (also with potential grooming at the end)
+    if (elm.child1_in_history<0){
+      // this is a leaf, i.e. with no further sustructure
+      PseudoJet & subjet = mapped_to_history[history_index]
+        = cs_jets[cs_history[elm.current_in_ca_tree].jetp_index];
+
+      StructureType * structure = new StructureType(subjet);
+      if (has_verbose_structure()){
+        structure->set_verbose(true);
+        structure->set_dropped_delta_R (elm.dropped_delta_R);
+        structure->set_dropped_symmetry(elm.dropped_symmetry);
+        structure->set_dropped_mu      (elm.dropped_mu);
+      }
+      subjet.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(structure));
+    } else {
+      PseudoJet & subjet = mapped_to_history[history_index]
+        = join(mapped_to_history[elm.child1_in_history], mapped_to_history[elm.child2_in_history]);
+      StructureType * structure = new StructureType(subjet, sqrt(elm.theta_squared), elm.symmetry, sqrt(elm.mu2));
+      if (has_verbose_structure()){
+        structure->set_verbose(true);
+        structure->set_dropped_delta_R (elm.dropped_delta_R);
+        structure->set_dropped_symmetry(elm.dropped_symmetry);
+        structure->set_dropped_mu      (elm.dropped_mu);
+      }
+      subjet.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(structure));
+    }    
+  } while (history_index>0);
+
+  return mapped_to_history[0];
+}
+
+// this routine applies the Soft Drop criterion recursively on the
+// CA tree, recursing into all the branches found during the previous iteration
+// until n layers have been found (or until it converges)
+PseudoJet RecursiveSoftDrop::result_fixed_depth(const PseudoJet &jet) const {
+  // start by reclustering jet with C/A algorithm
+  PseudoJet ca_jet = _recluster_if_needed(jet);
+
+  if (! ca_jet.has_valid_cluster_sequence()){
+    throw Error("RecursiveSoftDrop can only be applied to jets associated to a (valid) cluster sequence");
+  }
+  
+  const ClusterSequence *cs = ca_jet.validated_cluster_sequence();
+  const vector<ClusterSequence::history_element> &cs_history = cs->history();
+  const vector<PseudoJet> &cs_jets = cs->jets();
+
+  // initialize counter to 1 subjet (i.e. the full ca_jet)
+  int n_depth = 0;
+  int max_njet = ca_jet.constituents().size();
+
+  // create the list of branches
+  unsigned int max_history_size = 2*max_njet;
+  //if ((_n>0) && (_n<max_njet-1)){ max_history_size = 2*(_n+1); }
+
+  // we need to pre-allocate the space for the vector so that the
+  // pointers are not invalidated
+  vector<internal_recursive_softdrop::RSDHistoryElement> history;
+  history.reserve(max_history_size);  // could be one shorter
+  history.push_back(internal_recursive_softdrop::RSDHistoryElement(ca_jet, this, _R0sqr));
+  history.back().theta_squared = _R0sqr;
+  
+  // create a priority queue containing the subjets and a comparison definition
+  // initialize counter to 1 subjet (i.e. the full ca_jet)
+  list<internal_recursive_softdrop::RSDHistoryElement*> active_branches;
+  active_branches.push_back(& (history[0]));
+
+  PseudoJet parent, piece1, piece2;
+  
+  while ((continue_grooming(n_depth)) && (active_branches.size())) {
+    // loop over all the branches and look for substructure
+    list<internal_recursive_softdrop::RSDHistoryElement*>::iterator hist_it=active_branches.begin();
+    while (hist_it!=active_branches.end()){
+      // get the element corresponding to the max dR
+      // and the associated PJ
+      internal_recursive_softdrop::RSDHistoryElement * elm = (*hist_it);
+      PseudoJet parent = cs_jets[cs_history[elm->current_in_ca_tree].jetp_index];
+
+      // we need to iterate this branch until we find some substructure
+      PseudoJet result_sd;
+      if (_dynamical_R0){
+        SoftDrop sd(_beta, _symmetry_cut, symmetry_measure(), sqrt(elm->theta_squared),
+                    mu_cut(), recursion_choice(), subtractor());
+        sd.set_reclustering(false);
+        sd.set_verbose_structure(has_verbose_structure());
+        result_sd = sd(parent);
+      } else {
+        result_sd = SoftDrop::result(parent);
+      }
+
+      // if we had an empty PJ, that means we ran into some problems.
+      // just return an empty PJ ourselves
+      if (result_sd == 0) return PseudoJet();
+      
+      // update the history element to reflect our iteration
+      elm->current_in_ca_tree = result_sd.cluster_hist_index();
+      
+      if (has_verbose_structure()){
+        elm->dropped_delta_R    = result_sd.structure_of<SoftDrop>().dropped_delta_R();
+        elm->dropped_symmetry   = result_sd.structure_of<SoftDrop>().dropped_symmetry();
+        elm->dropped_mu         = result_sd.structure_of<SoftDrop>().dropped_mu();
+      }
+
+      // if some substructure was found:
+      if (result_sd.structure_of<SoftDrop>().has_substructure()){
+        // update the history element to reflect our iteration
+        elm->child1_in_history  = history.size();
+        elm->child2_in_history  = history.size()+1;
+        elm->theta_squared      = result_sd.structure_of<SoftDrop>().delta_R();
+        elm->theta_squared     *= elm->theta_squared;
+        elm->symmetry           = result_sd.structure_of<SoftDrop>().symmetry();
+        elm->mu2                = result_sd.structure_of<SoftDrop>().mu();
+        elm->mu2               *= elm->mu2;
+             
+        // the next iteration will have to handle 2 new history
+        // elements (the R0squared argument here is unused)
+        result_sd.has_parents(piece1, piece2);
+        internal_recursive_softdrop::RSDHistoryElement elm1(piece1, this, _R0sqr);
+        history.push_back(elm1);
+        // insert it in the active branches if needed
+        if (elm1.theta_squared>0)
+          active_branches.insert(hist_it,&(history.back())); // insert just before
+
+        internal_recursive_softdrop::RSDHistoryElement elm2(piece2, this, _R0sqr);
+        history.push_back(elm2);
+        if ((!_hardest_branch_only) && (elm2.theta_squared>0)){
+          active_branches.insert(hist_it,&(history.back())); // insert just before
+        }
+      }
+      // otherwise we've just reached the end of the recursion the
+      // history information has been updated above
+      //
+      // we just need to make sure that we do not recurse into that
+      // element any longer
+
+      list<internal_recursive_softdrop::RSDHistoryElement*>::iterator current = hist_it;
+      ++hist_it;
+      active_branches.erase(current);
+    } // loop over branches at current depth
+    ++n_depth;
+  } // loop over depth
+
+  // now we have a bunch of history elements that we can use to build the final jet
+  vector<PseudoJet> mapped_to_history(history.size());
+  unsigned int history_index = history.size();
+  do {
+    --history_index;
+    const internal_recursive_softdrop::RSDHistoryElement & elm = history[history_index];
+
+    // two kinds of events: either just a final leave, poteitially  with grooming
+    // or a brandhing (also with potential grooming at the end)
+    if (elm.child1_in_history<0){
+      // this is a leaf, i.e. with no further sustructure
+      PseudoJet & subjet = mapped_to_history[history_index]
+        = cs_jets[cs_history[elm.current_in_ca_tree].jetp_index];
+
+      StructureType * structure = new StructureType(subjet);
+      if (has_verbose_structure()){
+        structure->set_verbose(true);
+      }
+      subjet.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(structure));
+    } else {
+      PseudoJet & subjet = mapped_to_history[history_index]
+        = join(mapped_to_history[elm.child1_in_history], mapped_to_history[elm.child2_in_history]);
+      StructureType * structure = new StructureType(subjet, sqrt(elm.theta_squared), elm.symmetry, sqrt(elm.mu2));
+      if (has_verbose_structure()){
+        structure->set_verbose(true);
+        structure->set_dropped_delta_R (elm.dropped_delta_R);
+        structure->set_dropped_symmetry(elm.dropped_symmetry);
+        structure->set_dropped_mu      (elm.dropped_mu);
+      }
+      subjet.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(structure));
+    }    
+  } while (history_index>0);
+
+  return mapped_to_history[0];
+}
+
+
+//========================================================================
+// implementation of the helpers
+//========================================================================
+
+// helper to get all the prongs in a jet that has been obtained using
+// RecursiveSoftDrop (instead of recursively parsing the 1->2
+// composite jet structure)
+vector<PseudoJet> recursive_soft_drop_prongs(const PseudoJet & rsd_jet){
+  // make sure that the jet has the appropriate RecursiveSoftDrop structure
+  if (!rsd_jet.has_structure_of<RecursiveSoftDrop>())
+    return vector<PseudoJet>();
+
+  // if this jet has no substructure, just return a 1-prong object
+  if (!rsd_jet.structure_of<RecursiveSoftDrop>().has_substructure())
+    return vector<PseudoJet>(1, rsd_jet);
+  
+  // otherwise fill a vector with all the prongs (no specific ordering)
+  vector<PseudoJet> prongs;
+
+  // parse the list of PseudoJet we still need to deal with
+  vector<PseudoJet> to_parse = rsd_jet.pieces();  // valid both for a C/A recombination step or a RSD join
+  unsigned int i_parse = 0;
+  while (i_parse<to_parse.size()){
+    const PseudoJet &current = to_parse[i_parse];
+
+    if ((current.has_structure_of<RecursiveSymmetryCutBase>()) &&
+        (current.structure_of<RecursiveSymmetryCutBase>().has_substructure())){
+      // if this has some deeper substructure, add it to the list of
+      // things to further process
+      vector<PseudoJet> pieces = current.pieces();
+      assert(pieces.size() == 2);
+      to_parse[i_parse] = pieces[0];
+      to_parse.push_back(pieces[1]);
+    } else {
+      // no further substructure, just add this as a branch
+      prongs.push_back(current);
+      ++i_parse;
+    }
+  }
+   
+  return prongs;
+}
+    
+}
+
+FASTJET_END_NAMESPACE
